﻿using System;
using System.IO;
using System.Net;
using Newtonsoft.Json;

namespace Karpach.IMDB
{
    public class Server
    {
        public string GetMovieTitleWithYear(string volumeLablel)
        {
            var request = WebRequest.Create(new Uri(string.Format("http://www.imdbapi.com/?t={0}", 
                volumeLablel.Replace('_', '+'))));
            request.Method = "GET";
            try
            {

                var response = request.GetResponse();                               
                var responseStream = response.GetResponseStream();
                if (responseStream != null)
                {
                    var reader = new StreamReader(responseStream);
                    var responseString = reader.ReadToEnd();
                    var movie = JsonConvert.DeserializeObject<Movie>(responseString);
                    if (movie != null && !string.IsNullOrEmpty(movie.Title))
                    {
                        return string.Format("{0} ({1})", movie.Title, movie.Year);
                    }

                }
            }
            catch
            { 
            }            
            return UppercaseWords(volumeLablel.Replace('_', ' ').ToLower());
        }               

        static string UppercaseWords(string value)
        {
            char[] array = value.ToCharArray();
            // Handle the first letter in the string.
            if (array.Length >= 1)
            {
                if (char.IsLower(array[0]))
                {
                    array[0] = char.ToUpper(array[0]);
                }
            }
            // Scan through the letters, checking for spaces.
            // ... Uppercase the lowercase letters following spaces.
            for (int i = 1; i < array.Length; i++)
            {
                if (array[i - 1] == ' ')
                {
                    if (char.IsLower(array[i]))
                    {
                        array[i] = char.ToUpper(array[i]);
                    }
                }
            }
            return new string(array);
        }
    }
}
